taskGenerator = function(

reduceSetOfTasks = 1, 
numbOfCues = 4,
saveFiles = 1
)
{

######################################################################
#################### create all possible cue patterns ################
######################################################################

pattern = data.frame(matrix(rep(c(1,-1), numbOfCues),
ncol = numbOfCues))

pattern = expand.grid(pattern)

######################################################################
#################### create all possible combinations ################
#################### between patterns ################################
######################################################################

combinationsPatterns = combn(1:NROW(pattern),2)

populationTasks = matrix(NA, NCOL(combinationsPatterns) * 
numbOfCues, 3)

populationTasks = matrix(NA, NCOL(combinationsPatterns) * 
numbOfCues, 3)

for (loopCombPatterns in 1 : NCOL(combinationsPatterns)){

populationTasks[((loopCombPatterns-1) * NCOL(pattern) + 1):
((loopCombPatterns) * NCOL(pattern)) ,] = 
cbind(loopCombPatterns,
unlist(pattern[combinationsPatterns[1,loopCombPatterns],]),
unlist(pattern[combinationsPatterns[2,loopCombPatterns],]))
}

######################################################################
#################### drop tasks that do not qualify  #################
#################### for the task set ################################
######################################################################

if (reduceSetOfTasks == 1){

evalPopulationsTasks = cbind(populationTasks[,1],
populationTasks[,2] + populationTasks[,3])

dropTasksFromSet = 
unique(evalPopulationsTasks[evalPopulationsTasks[,2]==-2,1])

patternQualified = 
populationTasks[populationTasks[,1] %in% dropTasksFromSet == FALSE,]

patternQualified[,1] =  
rep(1: (NROW(patternQualified)/numbOfCues), each = numbOfCues)

}else{

patternQualified = populationTasks
}

######################################################################
#################### save set of qualified tasks  ###################
######################################################################

colnames(patternQualified) = 
c("Task.Number", "Option.A", "Option.B")

if (saveFiles == 1){

write.csv(patternQualified,"tasks.csv", row.names = F)
}

return(patternQualified)
}
